// ------------------------------------------------------------------------------
//  <autogenerated>
//      This code was generated by a tool.
//      Mono Runtime Version: 4.0.30319.1
// 
//      Changes to this file may cause incorrect behavior and will be lost if 
//      the code is regenerated.
//  </autogenerated>
// ------------------------------------------------------------------------------
using UnityEngine;
using System.Collections;
using System.Runtime.InteropServices;
using KTPlaySDKJson;


public class KTAccountManagerCallbackParams
{
	private const string KEY_WHAT = "what";
	private const string KEY_PARAMS = "params";
	private const string KEY_REQINFO = "KTChat";
	
	public enum KTAccountManagerEvent
	{
		/// <summary>
		///   KTPlay登录状态变更事件
		/// </summary>
		KTPlayAccountEventStatusChange = 100,
		/// <summary>
		///   获取KTplay用户信息事件
		/// </summary>
		KTPlayAccountEventUserProfile,
		/// <summary>
		///   打开KTPlay登录界面的登录信息事件
		/// </summary>
		KTPlayAccountEventLoginViewLogin,
		/// <summary>
		///    使用网游帐户登录的登录信息事件
		/// </summary>
		KTPlayAccountEventLoginWhithGameUser,
		/// <summary>
		///   修改当前登录帐户昵称事件
		/// </summary>
		KTPlayAccountEventSetNickName,
		/// <summary>
		///   修改当前登录帐户配置文件
		/// </summary>
		KTPlayAccountEventUpdateProfile,
                /// <summary>
		///   修改当前登录帐户VIP
		/// </summary>
		KTPlayAccountEventUpdateVipLevel
	};
	
	public KTAccountManagerEvent accountManagerEventResult;
	public KTUser statusUser = null;
	public bool isLogin = false;
	public KTUser oneUser = null;
	public string userId = null;
	public string gameUserId = null;
	public string nickName = null;
	public KTError userProfileError = null;
	public KTError loginViewError = null;
	public KTError loginWhithGameUserError = null;
	public KTError accountEventSetNickNameError = null;
	public KTError accountEventUpdateProfileError = null;
    public KTError accountEventUpdateVipLevelError = null;
	public KTUser profileUser = null;
	public bool isSuccess = false;

	public void ParseFromString(string s)
	{
		Hashtable data = (Hashtable)KTJSON.jsonDecode(s);
		if(data[KEY_WHAT] != null)
		{
			this.accountManagerEventResult = (KTAccountManagerEvent)((double)data[KEY_WHAT]);
			switch(this.accountManagerEventResult)
			{
				case KTAccountManagerEvent.KTPlayAccountEventStatusChange:
				{
					Hashtable param = (Hashtable)data[KEY_PARAMS];
					if(param["userId"] == null)
					{
						statusUser = null;
					}
					else
					{
						statusUser = new KTUser(param);
					}
					if((bool)param["isLogin"] == true)
					{
						isLogin = true;
					}
					else
					{
						isLogin = false;
					}
				} break;
				case KTAccountManagerEvent.KTPlayAccountEventUserProfile:
				{
					Hashtable param = (Hashtable)data[KEY_PARAMS];
					if (param ["error_code"] == null) {
						if(param["userId"] == null)
						{
							oneUser = null;
						}
						else
						{
							oneUser = new KTUser(param);
						}
					} else {

						userProfileError = new KTError (param);
					}
					if(data[KEY_REQINFO] != null)
					{
						Hashtable KTChat = (Hashtable)data[KEY_REQINFO];
						userId = (string)KTChat[@"userId"];
					}
				} break;
				case KTAccountManagerEvent.KTPlayAccountEventLoginViewLogin:
				{
					Hashtable param = (Hashtable)data[KEY_PARAMS];
					if (param ["error_code"] == null) {
						if(param["userId"] == null)
						{
							oneUser = null;
						}
						else
						{
							oneUser = new KTUser(param);
						}
					} else {
						loginViewError  = new KTError (param);
					}
					if(data[KEY_REQINFO] != null)
					{
						Hashtable KTChat = (Hashtable)data[KEY_REQINFO];
						userId = (string)KTChat[@"userId"];
					}
				} break;
				case KTAccountManagerEvent.KTPlayAccountEventLoginWhithGameUser:
				{
					Hashtable param = (Hashtable)data[KEY_PARAMS];
					if (param ["error_code"] == null) {
						if(param["userId"] == null)
						{
							oneUser = null;
						}
						else
						{
							oneUser = new KTUser(param);
						}
					} else {
						loginWhithGameUserError  = new KTError (param);
					}
					if(data[KEY_REQINFO] != null)
					{
						Hashtable KTChat = (Hashtable)data[KEY_REQINFO];
						gameUserId = (string)KTChat[@"gameUserId"];
					}
				} break;
				case KTAccountManagerEvent.KTPlayAccountEventSetNickName:
				{
					Hashtable param = (Hashtable)data[KEY_PARAMS];
					if (param ["error_code"] == null) {
						if(param["userId"] == null)
						{
							oneUser = null;
						}
						else
						{
							oneUser = new KTUser(param);
						}
					} else {
						accountEventSetNickNameError  = new KTError (param);
					}
					if(data[KEY_REQINFO] != null)
					{
						Hashtable KTChat = (Hashtable)data[KEY_REQINFO];
						nickName = (string)KTChat[@"nickName"];
					} 
				} break;
				case KTAccountManagerEvent.KTPlayAccountEventUpdateProfile:
				{
					Hashtable param = (Hashtable)data[KEY_PARAMS];
					if(param["error_code"] == null)
					{
						accountEventUpdateProfileError = null;
					}
					else
					{
						accountEventUpdateProfileError = new KTError (param);
					}
					if(param["userId"] == null)
					{
						profileUser = null;
					}
					else
					{
						profileUser = new KTUser(param);
					}
					if(param["isSuccess"] != null)
					{
						isSuccess = (bool)param ["isSuccess"];
					}
				} break;
				case KTAccountManagerEvent.KTPlayAccountEventUpdateVipLevel:
				{
					Hashtable param = (Hashtable)data[KEY_PARAMS];
					if(param["error_code"] == null)
					{
						accountEventUpdateVipLevelError = null;
					}
					else
					{
						accountEventUpdateVipLevelError = new KTError (param);
					}
					if(param["userId"] == null)
					{
						profileUser = null;
					}
					else
					{
						profileUser = new KTUser(param);
					}
					if(param["isSuccess"] != null)
					{
						isSuccess = (bool)param ["isSuccess"];
					}
				} break;
			}
		}
	}
	
	public KTAccountManagerCallbackParams(string s)
	{
		this.ParseFromString(s);
	}
};

